/*
**  This is a simple program to show the use of frmk_do().
**    tab width: 8
*/

#include <osbind.h>
#include <obdefs.h>
#include <gemdefs.h>
#include "sample.h"

static OBJECT *rscad;
static GRECT r1;

main()
	{
	int ret;

	/*
	**  The integer array below defines which objects in the dialog
	**  will respond to which keys.
	*/
	static int keysub[] = {
	 RB1, 187,'1','W','w',-1,	/* F1 etc. */
	 RB2, 188,'2','A','a',-1,	/* F2 */
	 RB3, 189,'3','R','r',-1,	/* F3 */
	 RB4, 190,'4','B','b',-1,	/* F4 */
	 HELPME, 226,'?','H','h',-1,	/* Help */
	 TOGGLE, 13, 210,'t','T',' ',-1,	/* Insert */
	 CANCEL, 225,27,199,'C','c',-1,	/* Undo,Esc,Clr-Home */
	 EXITB, 'D','d',-1,	/* default obj; Returns works too */
	 -2 };			/* terminate list, return all keys */
	
	appl_init();

	rsrc_load( "sample.rsc" );
	rsrc_gaddr( R_TREE, TREE1, &rscad );
	form_center( rscad, &r1.g_x,&r1.g_y,&r1.g_w,&r1.g_h );
	
	f_d( 0 );
	f_d( 1 );
	objc_draw( rscad, 0, 8, r1.g_x,r1.g_y,r1.g_w,r1.g_h );
	graf_mouse( 0, 0L );

	do {
	  ret = frmk_do( rscad, keysub );

	  /* without frmk_do(), "ret = form_do( rscad, 0 );" */

	  switch( ret ) {
	    case HELPME:
	      form_alert( 1,"[3][Need help?][Naw]" );
	      clr_ob( HELPME );
	      break;

	    case CANCEL:  /* back to original settings */
	      set_ob( RB1 );
	      clr_ob( RB2 );
	      clr_ob( RB3 );
	      clr_ob( RB4 );
	      clr_ob( TOGGLE );
	      clr_ob( CANCEL );
	      break;
	  
	    case 16384 + 203: /* L arrow   */
	    case 16384 +   8: /* Backspace */
	      decr_rad();
	      break;

	    case 16384 + 205: /* R arrow   */
	    case 16384 +   9: /* Tab       */
	      incr_rad();
	      break;

	    } /* end switch( ret ) */

	  } while( ret != EXITB );
	
	f_d( 2 );
	f_d( 3 );

	rsrc_free();
	appl_exit();
	return(0);
	}

incr_rad() { /* move to next radio button on right */
	if( rscad[RB1].ob_state & SELECTED ) {
	  clr_ob(RB1); set_ob(RB2); }
	else if( rscad[RB2].ob_state & SELECTED ) {
	  clr_ob(RB2); set_ob(RB3); }
	else if( rscad[RB3].ob_state & SELECTED ) {
	  clr_ob(RB3); set_ob(RB4); }
	else if( rscad[RB4].ob_state & SELECTED ) {
	  clr_ob(RB4); set_ob(RB1); }
	}

decr_rad() { /* move to next radio button on left */
	if( rscad[RB1].ob_state & SELECTED ) {
	  clr_ob(RB1); set_ob(RB4); }
	else if( rscad[RB2].ob_state & SELECTED ) {
	  clr_ob(RB2); set_ob(RB1); }
	else if( rscad[RB3].ob_state & SELECTED ) {
	  clr_ob(RB3); set_ob(RB2); }
	else if( rscad[RB4].ob_state & SELECTED ) {
	  clr_ob(RB4); set_ob(RB3); }
	}

clr_ob( index )
int index;
	{
	objc_change( rscad, index, 0, r1.g_x,r1.g_y,r1.g_w,r1.g_h,
	  rscad[index].ob_state & ~SELECTED, 1 );
	}

set_ob( index )
int index;
	{
	objc_change( rscad, index, 0, r1.g_x,r1.g_y,r1.g_w,r1.g_h,
	  rscad[index].ob_state | SELECTED, 1 );
	}

f_d( param )   /* shorthand form_dialog call */
int param;
	{
	form_dial( param, 0,0,0,0,
	  r1.g_x,r1.g_y,r1.g_w,r1.g_h );
	}
	